var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {});
initSpread(spread);
function initSpread(spread) {
  let sheet = spread.getActiveSheet();
  sheet.options.clipBoardOptions =
    GC.Spread.Sheets.ClipboardPasteOptions.values;
  var pasteInfo = {
    sorurceRange: null,
  };
  addSpan(sheet);
  spread.bind(GC.Spread.Sheets.Events.ClipboardPasted, (e, args) => {
    if (
      rangeContainSpan(
        args.sheet,
        args.cellRange
      ) &&
      args.fromRange?.colCount === 1 &&
      args.cellRange.colCount === 1
    ) {
      putValues(args.sheet, args.cellRange, args.pasteData.text);
    }
    else if (rangeContainSpan(args.sheet, pasteInfo.fromRange)) {
      //handle the case when copy happen on spanned range
      //idea is to traverse the cell from up to down and if any null value get found then 
      //replace the value from next value inside the past3e cell range
      let cellRange = args.cellRange;
      debugger;
      for (let row = cellRange.row; row < cellRange.row + cellRange.rowCount; row++) {
        for (let col = cellRange.col; col < cellRange.col + cellRange.colCount; col++) {
          if (sheet.getValue(row, col) === null) {
            let nextValue = getNextValue(sheet, row, col, Math.abs((cellRange.rowCount + cellRange.row)));
            sheet.setValue(row, col, nextValue);
          }
        }

      }
    }
  });
  spread.bind(GC.Spread.Sheets.Events.ClipboardChanged, (e, args) => {
    pasteInfo.fromRange = args.sheet.getSelections()[0];
  });
}

function getNextValue(sheet, row, col, lastRowToLook) {
  for (let i = row; i < lastRowToLook; i++) {
    let val = sheet.getValue(i, col);
    if (val) {
      sheet.setValue(i, col, null);
      return val;
    }
  }
  return null;
}
function addSpan(sheet) {
  sheet.suspendPaint();
  for (let i = 1; i < 11; i += 2) {
    sheet.addSpan(i, 0, 2, 1);
  }
  addData(sheet);
  sheet.resumePaint();
}
function addData(sheet) {
  sheet.suspendPaint();
  for (let i = 0; i < 10; i++) {
    sheet.setValue(i, 1, i);
  }
  sheet.resumePaint();
}
function putValues(sheet, range, text) {
  let rowData = text.split("\n");
  let k = 0;
  for (let i = range.row; i < sheet.getRowCount(); i++) {
    if (!isSpanned(sheet, i, range.col)) {
      sheet.setValue(i, range.col, rowData[k++]);
    }
  }
}

function isSpanned(sheet, row, col) {
  let flag = false;
  sheet.getSpans().forEach((span) => {
    if (
      (span.row < row && span.rowCount + span.row > row) ||
      (span.col < col && span.colCount + span.col > col)
    ) {
      flag = true;
      return;
    }
  });
  return flag;
}
function rangeContainSpan(sheet, range) {
  flag = false;
  if (!range instanceof GC.Spread.Sheets.Range)
    range = new GC.Spread.Sheets.Range(
      range.row,
      range.col,
      range.rowCount,
      range.colCount
    )
  sheet.getSpans().forEach((span) => {
    if (range.contains(span.row, span.col, span.rowCount, span.colCount)) {
      flag = true;
      return;
    }
  });
  return flag;
}
